#include "pyutil.hpp"
#include <vector>

typedef std::pair<int(*)(void*), void*> Func;
typedef std::vector<Func> CallQueue;
static CallQueue g_callQueue;
static ost::Mutex  g_critSectionPyCall("CritSectionPyCall");
static ost::Event g_actionEvent;

void _Py_AddPendingCall(int(*func)(void*), void *arg)
{
  g_critSectionPyCall.enterMutex();
  g_callQueue.push_back(Func(func, arg));
  g_critSectionPyCall.leaveMutex();
}

void _Py_MakePendingCalls()
{
  g_critSectionPyCall.enterMutex();

  CallQueue::iterator iter = g_callQueue.begin();
  while (iter != g_callQueue.end())
  {
    int(*f)(void*) = (*iter).first;
    void* arg = (*iter).second;
    g_callQueue.erase(iter);
    g_critSectionPyCall.leaveMutex();
    if (f)
      f(arg);
    //(*((*iter).first))((*iter).second);
    g_critSectionPyCall.enterMutex();
    iter = g_callQueue.begin();
  }
  g_critSectionPyCall.leaveMutex();  
}

void Py_WaitForActionEvent()
{
  g_actionEvent.wait();
  g_actionEvent.reset();
}

void Py_PulseActionEvent()
{
  g_actionEvent.signal();
}
