#ifndef REPLAY_DEVICE_HPP
#define REPLAY_DEVICE_HPP

#include "input_device.hpp"

#include <queue>

class ReplayDevice : public InputDevice
{
private:
  std::queue<std::pair<timespec, Input> > inputs;
  timespec time_start;

  void generate_search_top()
  {}

  void generate_search_input(std::string& str, std::string& lstr, int& offset, Input input)
  {}

  void search_top()
  {}

  void search_input(std::string& str, std::string& lowercase_search_str, Input input, int& offset,
		    const boost::function<std::vector<std::string> (const std::string&)>& list_gen,
		    const boost::function<int (const std::string&)>& list_size)
  {}

  void search_graphical_input(std::string& str, std::string& lowercase_search_str, Input input,
			      int& offset, int& pos, int& search_help_offset, bool graphical_print, int row_size,
			      const boost::function<int (const std::string&)>& list_size)
  {}

public:
  ReplayDevice();
  ~ReplayDevice() { terminate(); }

  bool init() { return true; }

  void suspend();
  void wake_up();

  void run();
};

#endif
